+ Reply to Thread
Page 1 of 3 1 2 3 LastLast
Results 1 to 10 of 25
  1. #1
    Senior Member
    Using
    Map 3D 2008
    Join Date
    Apr 2009
    Location
    The one after 909
    Posts
    402

    Default The Best Text Find And Replace LISP Ever...

    Registered forum members do not see this ad.

    ... is not this one.

    But, I am fairly pleased with it. It's been quite some time in the making, and I used a different strategy with my code (folks who remember BASIC might crack a smile).

    I'd just like to post this, and get some feedback. I'm sure there are ways to improve the functionality or efficiency, namely removing Visual LISP so that it's more backwards compatible, or adding an option to go back up a menu or two, or even alter the selection set (or, put the selection set elsewhere, since text-heavy drawings like landbases with street names would lag when this LISP is called).

    Any advice would be greatly appreciated. Thank you. ^.^

    Code:
    ;-============-;
    ;- Text  Find -;
    ;-    *~*     -;
    ;  Written by -;
    ; Mark Mercier ;
    ;   05-06-09   ;
    ;-============-;
    
    ; Improvements:
    ; Text within blocks
    ; Improved selection set.. maybe do away with the whole "list" thing and go straight VLA
    
    (defun c:tfind()
      (tfindfun nil nil 0)
      )
    
    (defun tfindfun(inputF inputR caseSn / goto goWhile strinF strinR selSet selTxt searep case count error)
      ; 01 Create selection set. GOTO 02 if success, or GOTO 08 if fail
      ; 02 Check passed input. If both nil, GOTO 03. If first string and second nil, GOTO 06. If both strings, GOTO 07. Otherwise, return error and GOTO 08
      ; 03 Display menus and obtain data from user. If Search, GOTO 04. If Replace, GOTO 05
      ; 04 Search option selected. Prompt user for single search term. GOTO 06
      ; 05 Replace option selected. Prompt user for search term and replace term. GOTO 07
      ; 06 One string has been passed. Assume automatic search. Run same as current (tfind). GOTO FINISH
      ; 07 Two strings have been passed. Assume automatic replace. Pass both strings to (replace) function. GOTO FINISH
      ; 08 FINISH. Return errors if needed. End loop and program.
      (vl-load-com)
      (setq goTo 1)
      (setq goWhile 1)
      (setq count 0)
      (if (not (mlml (list caseSn) (list 0 1))) (progn (setq goWhile nil) (princ "\nCase selection not recognized.")))
      (if (= caseSn 0) (setq case "N") (setq case "Y"))
      (while goWhile
        (cond
          ((= goTo 1)
           (setq selSet (extTxtPt (ssget "_X" (list (cons -4 "<OR") (cons 0 "TEXT,MTEXT") (cons -4 "<AND") (cons 0 "INSERT") (cons 66 1) (cons -4 "AND>") (cons -4 "OR>")))))
           (if selSet (setq goTo 2) (setq error "\nSelection set not found." goTo 8))
           )
          ((= goTo 2)
           ; Check input, pass to whatever.
           (cond
         ((and (= inputF nil) (= inputR nil))
          (setq goTo 3)
          )
         ((and (= (type inputF) 'STR) (= inputR nil))
          (setq strinF inputF)
          (setq goTo 6)
          )
         ((and (= (type inputF) 'STR) (= (type inputR) 'STR))
          (setq strinF inputF)
          (setq strinR inputR)
          (setq goTo 7)
          )
         (t
          (setq error "\nPassed arguments are not accepted.")
          (setq goTo 8)
          )
         )
           )
          ((= goTo 3)
           ; Obtain desired option from user
           (while (not (mlml (list (setq searep (strcase (getstring nil "\nSelect option [Find/Replace/Quit/Case]: "))))
                     (list "F" "FIND" "R" "REPLACE" "Q" "QUIT" "C" "CASE")
                     ))
         )
           (cond
         ((mlml (list searep) (list "F" "FIND"))
          (setq goTo 4)
          )
         ((mlml (list searep) (list "R" "REPLACE"))
          (setq goTo 5)
          )
         ((mlml (list searep) (list "Q" "QUIT"))
          (setq goTo 8)
          )
         ((mlml (list searep) (list "C" "CASE"))
          (while (not (mlml (list (setq case (strcase (getstring nil "\nCase sensitive? [Yes/No]: "))))
                        (list "Y" "YES" "N" "NO")
                        ))
            )
          )
         )
           )
          ((= goTo 4)
           ; Obtain search string from user, set to strinF
           (while (eq "" (setq strinF (getstring T "\nEnter search term: "))))
           (setq goTo 6)
           )
          ((= goTo 5)
           ; Obtain search string and replace string from user, set to strinF and strinR respectively
           (while (eq "" (setq strinF (getstring T "\nEnter find term: "))))
           (while (eq "" (setq strinR (getstring T "\nEnter replace term: "))))
           (setq goTo 7)
           )
          ((= goTo 6)
           ; Search drawing for strinF
           (cond
         ((mlml (list case) (list "Y" "YES"))
          ; Compare using (vl-string-search strinF input), view selection
          ; use "while" to get all search occurances
          (foreach selVar selSet
            (if (vl-string-search strinF (nth 0 selVar))
              (progn
            (setq count (1+ count))
            (if (/= (getvar "ctab") (caddr selVar)) (command "ctab" (caddr selVar)))
            (command "zoom" "c" (trans (cadr selVar) 0 1) (* 32 (nth 3 selVar)))
            (getstring "\nPress 'Enter' to continue: ")
            )
              )
            )
          )
         ((mlml (list case) (list "N" "NO"))
          ; Compare using (vl-string-search (strcase strinF) (strcase input)), view selection
          ; use "while" to get all search occurances
          (foreach selVar selSet
            (if (vl-string-search (strcase strinF) (strcase (nth 0 selVar)))
              (progn
            (setq count (1+ count))
            (if (/= (getvar "ctab") (caddr selVar)) (command "ctab" (caddr selVar)))
            (command "zoom" "c" (trans (cadr selVar) 0 1) (* 32 (nth 3 selVar)))
            (getstring "\nPress 'Enter' to continue: ")
            )
              )
            )
          )
         )
           (if (= count 0) (setq error "\nNo matches found.") (setq error (strcat (itoa count) " matches found.")))
           (setq goTo 8)
           )
          ((= goTo 7)
           ; Replace strinF with strinR
           (cond
         ((mlml (list case) (list "Y" "YES"))
          ; Compare using (vl-search-string strinF input), modify using (vl-string-subst) within a while loop
          (foreach selVar selSet
            (setq selTxt (nth 0 selVar))
            (setq seaLoc 0)
            (while (setq seaLoc (vl-string-search strinF selTxt seaLoc))
              (setq selTxt (vl-string-subst strinR strinF selTxt seaLoc))
              (setq seaLoc (+ seaLoc (strlen strinR)))
              (setq count (1+ count))
              )
            (vla-put-TextString (vlax-ename->vla-object (nth 4 selVar)) selTxt)
            )
          )
         ((mlml (list case) (list "N" "NO"))
          ; Compare using (vl-string-search (strcase strinF) (strcase input)), modify using (vl-string-subst) within a while loop
          (foreach selVar selSet
            (setq selTxt (nth 0 selVar))
            (setq seaLoc 0)
            (while (setq seaLoc (vl-string-search (strcase strinF) (strcase selTxt) seaLoc))
              (setq selTxt (strcat (substr selTxt 1 seaLoc) strinR (substr selTxt (+ 1 seaLoc (strlen strinF)))))
              (setq seaLoc (+ seaLoc (strlen strinR)))
              (setq count (1+ count))
              )
            (vla-put-TextString (vlax-ename->vla-object (nth 4 selVar)) selTxt)
            )
          )
         )
           (if (= count 0) (setq error "\nNo occurances found.") (setq error (strcat (itoa count) " occurances modified.")))
           (setq goTo 8)
           )
          ((= goTo 8)
           (if error (princ error))
           (setq goWhile nil)
           )
          )
        )
      (princ)
      )
    
    (defun mlml(inSMLChar inSMLStri / returnVarMS toCheck chkWith)
      (setq returnVarMS nil)
      (if (and (= (type inSMLChar) 'LIST)
           (= (type inSMLStri) 'LIST)
           )
        (progn
          (foreach toCheck inSMLStri
        (foreach chkWith inSMLChar
          (if (eq toCheck chkWith) (setq returnVarMS T))
          )
        )
          );/progn
        )
      returnVarMS
      ); Checks a list to see if a member of that list is the same as a member of another list. Returns T or nil
    
    (defun extTxtPt(ssList / subVar getEnt entTyp entTxt entPnt entLay entHgt grp66 entAtt getEntAtt entAttTyp uniLst)
      (setq uniLst nil)
      (setq subVar 0)
      (if ssList
      (repeat (sslength ssList)
        (setq getEnt (entget (cadr (car (ssnamex ssList subVar)))))
        (setq entTyp (cdr (assoc 0 getEnt)))
        (cond
          ((or (= entTyp "TEXT") (= entTyp "MTEXT"))
           (setq entTxt (cdr (assoc 1 getEnt)))
           (setq entPnt (cdr (assoc 10 getEnt)))
           (setq entHgt (cdr (assoc 40 getEnt)))
           (setq entLay (cdr (assoc 410 getEnt)))
           (setq entNam (cdr (assoc -1 getEnt)))
    
           (setq uniLst (append uniLst (list (list entTxt entPnt entLay entHgt entNam))))
           )
          ((= entTyp "INSERT")
           (setq grp66 (assoc 66 getEnt))
           (if grp66
         (progn
           (setq entAtt (entnext (cdr (assoc -1 getEnt))))
               (setq getEntAtt (entget entAtt))
               (setq entAttTyp (cdr (assoc 0 getEntAtt)))
           )
         )
           (while (= entAttTyp "ATTRIB")
         (setq entTxt (cdr (assoc 1 getEntAtt)))
         (setq entPnt (cdr (assoc 10 getEntAtt)))
             (setq entHgt (cdr (assoc 40 getEntAtt)))
         (setq entLay (cdr (assoc 410 getEntAtt)))
         (setq entNam (cdr (assoc -1 getEntAtt)))
         
         (setq uniLst (append uniLst (list (list entTxt entPnt entLay entHgt entNam))))
    
         ; Get next entity.
         (setq entAtt (entnext (cdr (assoc -1 getEntAtt))))
    
         ; Get ent and ent type
         (setq getEntAtt (entget entAtt))
         (setq entAttTyp (cdr (assoc 0 getEntAtt)))
         )
           )
          (t
           )
          )
        (setq subVar (1+ subVar))
        )
        )
      uniLst
      ); Return list of all text-based objects (Text, MText, Attribute) in the current drawing
    Last edited by Freerefill; 8th Jul 2009 at 05:08 pm.

  2. #2
    Forum Deity
    Using
    AutoCAD 2009
    Join Date
    Oct 2008
    Posts
    2,112

    Default

    Freerefill,

    It is a very good routine for a Lisp no doubt, But if it were Dialog driven it would be a nice improvement.

    Thanks for the share.
    The Buzzard

  3. #3
    Quantum Mechanic Lee Mac's Avatar
    Computer Details
    Lee Mac's Computer Details
    Operating System:
    Windows 7 Ultimate (32-bit)
    Discipline
    Multi-disciplinary
    Lee Mac's Discipline Details
    Discipline
    Multi-disciplinary
    Details
    Custom Programming / Software Customisation
    Using
    AutoCAD 2013
    Join Date
    Aug 2008
    Location
    London, England
    Posts
    16,922

    Default

    Nice Program

    Just a quick thing I have noticed - you use a sub-function: mlml... why not use the "member" function to accomplish such a task?

    Also, with your option selection - why not use an initget, and a getkword, instead of running it through several sub-functions to determine if it is an allowed option?

    Just a few things I noticed - but good program all the same

    Lee
    Lee Mac ProgrammingTwitterExchange App StoreDropbox (500MB free)

    With Mathematics there is the possibility of perfect rigour, so why settle for less?

  4. #4
    Quantum Mechanic Lee Mac's Avatar
    Computer Details
    Lee Mac's Computer Details
    Operating System:
    Windows 7 Ultimate (32-bit)
    Discipline
    Multi-disciplinary
    Lee Mac's Discipline Details
    Discipline
    Multi-disciplinary
    Details
    Custom Programming / Software Customisation
    Using
    AutoCAD 2013
    Join Date
    Aug 2008
    Location
    London, England
    Posts
    16,922

    Default

    Quote Originally Posted by The Buzzard View Post
    Freerefill,

    It is a very good routine for a Lisp no doubt, But if it were Dialog driven it would be a nice improvement.

    Thanks for the share.
    The Buzzard

    You and your dialogs
    Lee Mac ProgrammingTwitterExchange App StoreDropbox (500MB free)

    With Mathematics there is the possibility of perfect rigour, so why settle for less?

  5. #5
    Quantum Mechanic Lee Mac's Avatar
    Computer Details
    Lee Mac's Computer Details
    Operating System:
    Windows 7 Ultimate (32-bit)
    Discipline
    Multi-disciplinary
    Lee Mac's Discipline Details
    Discipline
    Multi-disciplinary
    Details
    Custom Programming / Software Customisation
    Using
    AutoCAD 2013
    Join Date
    Aug 2008
    Location
    London, England
    Posts
    16,922

    Default

    Also, why not use a Selection Set filter when retrieveing your text based items?
    Lee Mac ProgrammingTwitterExchange App StoreDropbox (500MB free)

    With Mathematics there is the possibility of perfect rigour, so why settle for less?

  6. #6
    Forum Deity
    Using
    AutoCAD 2009
    Join Date
    Oct 2008
    Posts
    2,112

    Default

    Are you up to it Lee?

    Just a mere bag a shells for someone like you.

  7. #7
    Senior Member
    Using
    Map 3D 2008
    Join Date
    Apr 2009
    Location
    The one after 909
    Posts
    402

    Default

    Quote Originally Posted by The Buzzard View Post
    Freerefill,

    It is a very good routine for a Lisp no doubt, But if it were Dialog driven it would be a nice improvement.

    Thanks for the share.
    The Buzzard
    Indeed! I had considered dialog boxes, but my goal was.. ok, well my original goal was to create one for a guy here who uses R14, which I did do but it never sat well with me how hack my code was.. I've always wanted to improve it.. anyway, my goal was to make one that allowed the user to skip the dialog box, namely the one when you type "FIND", and use it strictly from the command line. Once I got put on AutoCAD 2009 and found that it did not retain the zoom when you searched for something, I realized that the one I made for R14 was actually very suitable, but in order to compete with the existing "FIND" dialog box, it at least needed to be able to replace text. That took a while to figure out, (ultimately I went with Visual LISP, which I suppose killed the goal of making it usable in R14, but the old one still exists, which is good ^^') but I managed it, and now I need to see if what I have can still grow into something more, or change into something better.

    Thank you for your reply ^^

  8. #8
    Quantum Mechanic Lee Mac's Avatar
    Computer Details
    Lee Mac's Computer Details
    Operating System:
    Windows 7 Ultimate (32-bit)
    Discipline
    Multi-disciplinary
    Lee Mac's Discipline Details
    Discipline
    Multi-disciplinary
    Details
    Custom Programming / Software Customisation
    Using
    AutoCAD 2013
    Join Date
    Aug 2008
    Location
    London, England
    Posts
    16,922

    Default

    Quote Originally Posted by The Buzzard View Post
    Are you up to it Lee?

    Just a mere bag a shells for someone like you.

    Haha - not sure about that... at that point you might as well use the AutoCAD Find and Replace.
    Lee Mac ProgrammingTwitterExchange App StoreDropbox (500MB free)

    With Mathematics there is the possibility of perfect rigour, so why settle for less?

  9. #9
    Forum Deity
    Using
    AutoCAD 2009
    Join Date
    Oct 2008
    Posts
    2,112

    Default

    I thought you would come back and say:

    "Ok just a quick one untested"

  10. #10
    Quantum Mechanic Lee Mac's Avatar
    Computer Details
    Lee Mac's Computer Details
    Operating System:
    Windows 7 Ultimate (32-bit)
    Discipline
    Multi-disciplinary
    Lee Mac's Discipline Details
    Discipline
    Multi-disciplinary
    Details
    Custom Programming / Software Customisation
    Using
    AutoCAD 2013
    Join Date
    Aug 2008
    Location
    London, England
    Posts
    16,922

    Default

    Registered forum members do not see this ad.

    Quote Originally Posted by The Buzzard View Post
    I thought you would come back and say:

    "Ok just a quick one untested"

    Haha you know me only too well
    Lee Mac ProgrammingTwitterExchange App StoreDropbox (500MB free)

    With Mathematics there is the possibility of perfect rigour, so why settle for less?

Similar Threads

  1. Find and replace text without a dialog box
    By y49sides in forum AutoLISP, Visual LISP & DCL
    Replies: 18
    Last Post: 9th Jan 2012, 03:34 pm
  2. Find and Replace text in several files.
    By guilhermecampos in forum AutoLISP, Visual LISP & DCL
    Replies: 5
    Last Post: 27th Mar 2010, 07:24 pm
  3. Find & Replace Text
    By drewd1508 in forum AutoLISP, Visual LISP & DCL
    Replies: 25
    Last Post: 19th Mar 2010, 09:57 pm
  4. Find/Replace text without a dialog box?
    By y49sides in forum AutoCAD Drawing Management & Output
    Replies: 3
    Last Post: 11th Jul 2009, 11:43 pm
  5. Find/Replace text?
    By Ste1978 in forum AutoLISP, Visual LISP & DCL
    Replies: 4
    Last Post: 16th Nov 2007, 03:28 pm

Bookmarks

Posting Permissions

  • You may not post new threads
  • You may not post replies
  • You may not post attachments
  • You may not edit your posts